load("sbbsdefs.js");
load("json-client.js");
load("frame.js");

// TODO:
// Prune Database Function.

// Color options

// var color_normal 		= "\1n\1b"; // Blue
var color_normal 		= "\1n\1r"; // Red
//var color_normal = "\1n\1c"; // Cyan
// var color_normal 		= "\1n\1y"; // Brown and Yellow
// var color_normal 		= "\1n\1m"; // Magenta
// var color_normal 		= "\1n\1g"; //Green

var color_bright = "\1h" + color_normal;
var color_white = "\1h\1w";

var screenrows = console.screen_rows;
var screencols = console.screen_cols;
var rumorlength = 64;

// Strings
var prompt_newrumor = " Enter new rumor [RET] quits:    ";
var prompt_newrumor2 = " <- Your Rumor";
var prompt_quit = "\0011\1r QUITING \0010";
var prompt_tomain = "\0011\1g BACK TO MAIN \0010";
var prompt_save = "\0012\1r SAVING \0010";
var prompt_gotoadmin = "\0015\1w Taking You To Admin \0010";
var prompt_pimprumor = leetcolor(
  " Pimp Your Rumor: [ARROWS] RANDOMIZE" + "  [RETURN] Save  [Q] Quit"
);
var prompt_pimprumor2 = " <- Pimp It!";
var prompt_manage = leetcolor(
  " Manage Your Rumors:" + " [ARROWS] Scroll  [D] Delete  [Q] Quit"
);
var prompt_askindex = " Delete Via Index ##:  ";
var prompt_notfound = "\0011 Index Not Found \0010";
var prompt_delete = "\0011 Delete Rumor(s) \0010";
var prompt_deleted = "\0012 Rumor(s) Deleted \0010";

var jsonServer = "localhost";
var jsonPort = "10088";

var hearsay_version = "Version 1.0 (2022.4)";

//Database Connection
var db = new JSONClient(jsonServer, jsonPort);
var totalrumors = db.read("hearsay", "rumors.length", 1);

// Frame Creation

var mainframe = new Frame(1, 1, screencols, screenrows, BG_BLACK);

var rumorsframe = new Frame(
  mainframe.x + 1,
  mainframe.y + 10,
  mainframe.width - 2,
  mainframe.height - 14,
  BG_BLACK | WHITE,
  mainframe
);

var promptframe = new Frame(
  mainframe.x + 2,
  rumorsframe.y + rumorsframe.height,
  rumorsframe.width - 2,
  1,
  BG_BLACK | WHITE,
  mainframe
);

var inputframe = new Frame(
  2,
  promptframe.y + promptframe.height + 1,
  rumorsframe.width,
  1,
  BG_BLACK | WHITE,
  mainframe
);

// Frame Configuration
mainframe.transparent = true;
inputframe.transparent = true;
promptframe.transparent = true;
rumorsframe.transparent = true;
mainframe.load(js.exec_dir + "hearsay-" + mainframe.width + ".ans");
showRumor(rumorsframe.height - 1, totalrumors);

mainframe.open();

// OPEN MAIN FRAME

function main() {
  // Main menu
  rumorsframe.clear();
  mainframe.cycle();

  stop = 0;

  while (stop == 0) {
    leetcolor(prompt_newrumor).topromptframe(1, 1);
    showRumor(rumorsframe.height, totalrumors);
    var padlen = rumorlength + prompt_newrumor2.length;
    var newrumor2 = color_bright + prompt_newrumor2.lpad(" ", padlen);
    newrumor2.toinputframe(1, 1, 0);
    console.gotoxy(inputframe.x, inputframe.y);
    // Get new rumor text
    var rumor = console.getstr("", rumorlength, K_LINE);
    switch (rumor.toUpperCase()) {
      case "":
      case "Q":
      case "QUIT":
      case "RET":
        // Quitting
        prompt_quit.topromptframe(1, 1, 500);
        stop = 1;
        break;

      case "ADMIN":
      case "MANAGE":
        if (user.is_sysop) {
          stop = 1;
          prompt_gotoadmin.topromptframe(1, 1, 750);
          managerumors();
        } 
        break;

      default:
        stop = 1;
        customizerumor(rumor);
        break;
    }
  }
}

function customizerumor(rumor) {
  // Rumor customization menu
  var db = new JSONClient(jsonServer, jsonPort);
  var num = db.read("hearsay", "rumors.length", 1);
  var rumorid = db.slice("hearsay", "rumors", num - 1, num, 1);

  //Foreground Colors
  var fgarray = {
    1: "\1n\1w",
    2: "\1n\1y",
    3: "\1n\1r",
    4: "\1h\1b",
    5: "\1n\1g",
    6: "\1n\1m",
    7: "\1h\1y",
    8: "\1h\1m",
  };
  // Background Colors
  var bgarray = {
    1: "\0010",
    2: "\0016",
    3: "\0012",
    4: "\0015",
    5: "\0014",
    6: "\0013",
    7: "\0011",
  };
  // Randomize Starting FB/BG Colors
  var fg = 1 + Math.floor(Math.random() * 7);
  var bg = 1 + Math.floor(Math.random() * 6);

  inputframe.clear();
  prompt_pimprumor.topromptframe(1, 0);

  var pimprumor2 =
    bracket(bgarray[bg] + fgarray[fg] + rpad(rumor, rumorlength)) +
    color_bright +
    prompt_pimprumor2;
  pimprumor2.toinputframe(0, 0, 0);

  // Recycle menu until favorable
  // color combonation is found
  var accepted = 0;
  while (!accepted) {
    mainframe.cycle();
    var key = console.getkey(K_NOECHO).toUpperCase();
    switch (key.toUpperCase()) {
      case "Q":
        prompt_tomain.topromptframe(1, 1, 500);
        accepted = 1;
        main();
        break;

      case "S":
      case "\r":
        // Saving Your Rumor
        var rumor_data = [];
        rumor_data = {
          id: rumorid[0].id + 1,
          bg: fgarray[fg],
          fg: bgarray[bg],
          therumor: rumor,
          user: user.alias,
        };
        // Really Saving Your Rumor
        prompt_save.topromptframe(1, 1, 750);
        saverumor(rumor_data);
        accepted = 1;
        break;

      default:
        // Keep randomizing
        var fg = 1 + Math.floor(Math.random() * 7);
        var bg = 1 + Math.floor(Math.random() * 6);
        var randomized =
          bracket(bgarray[bg] + fgarray[fg] + rpad(rumor, rumorlength)) +
          color_bright +
          prompt_pimprumor2;
        randomized.toinputframe(1, 1, 0);
        break;
    }
  }
}

function managerumors() {
  // Simple Rumor management
  // Delete rumor by index
  var db = new JSONClient(jsonServer, jsonPort);
  var startrumor = totalrumors;

  inputframe.clear();
  promptframe.clear();
  rumorsframe.clear();
  showRumor(rumorsframe.height, startrumor, 1);

  // Manage Rumors Prompt
  prompt_manage.topromptframe(1, 1);
  mainframe.cycle();

  // Recycle menu until you see rumor to delete
  // or you get tired of scrolling.
  var accepted = 0;
  while (!accepted) {
    prompt_manage.topromptframe(1, 1);
    mainframe.cycle();
    var key = console.getkey(K_NOECHO).toUpperCase();
    switch (key) {
      case KEY_DOWN:
        startrumor = startrumor + 1;
        if (startrumor > totalrumors) startrumor = totalrumors;
        rumorsframe.clear();
        showRumor(rumorsframe.height, startrumor, 1);
        rumorsframe.cycle();
        break;

      case KEY_UP:
        startrumor = startrumor - 1;
        if (startrumor <= rumorsframe.height - 2) startrumor = startrumor + 1;
        rumorsframe.clear();
        showRumor(rumorsframe.height, startrumor, 1);
        rumorsframe.cycle();
        break;

      case "D":
        // Ask For Index to Delete
        leetcolor(prompt_askindex).topromptframe(1, 1);
        console.gotoxy(prompt_askindex.length, promptframe.y);
        var index = console.getstr("", 3, K_LINE | K_NUMBER);
        //showRumor(1,index);
        //sleep(500)
        inputframe.cycle();
        promptframe.clear();
        promptframe.cycle;
        if (index > totalrumors || index == "") {
          prompt_notfound.topromptframe(1, 1, 1500);
          break;
        }

        var prompt_text = "Are we really doing this? (Y/N) ";
        prompt_text.topromptframe(1, 1, 0);
        var yesorno = console.getkey().toUpperCase();
        if (yesorno == "Y") {
          removerumor(index, 1);
          prompt_deleted.topromptframe(1, 1, 500);
          totalrumors = db.read("hearsay", "rumors.length", 1);
          rumorsframe.clear();
          showRumor(rumorsframe.height, totalrumors, 1);
          rumorsframe.cycle();
        }
        inputframe.clear();
        inputframe.cycle();
        break;

      case "\r":
      case "Q":
        // Quiting
        prompt_tomain.topromptframe(1, 1, 500);
        accepted = 1;
        main();
        break;

      case "V":
        // Get Version Information
        prompt_v = "Hearsay! Version " + hearsay_version;
        prompt_v.topromptframe(1, 1, 2000);
        break;
      default:
        break;
    }
  }
}

function removerumor(index, num) {
  var db = new JSONClient(jsonServer, jsonPort);
  var r = db.read("hearsay", "rumors", 1);
  r.splice(index, num);
  db.write("hearsay", "rumors", r, 2);
  return;
}

function saverumor(rumor_data) {
  var db = new JSONClient(jsonServer, jsonPort);
  db.push("hearsay", "rumors", rumor_data, 2);
}

function showRumor(n, last, admin) {
  // showrumor(0);    == Random rumor
  // showrumor(1,22); == Show one rumor from index 22
  // showrumor(1,10); == Show all rumors from indexs 1-10
  var db = new JSONClient(jsonServer, jsonPort);
  var totalrumors = db.read("hearsay", "rumors.length", 1);
  var prompt_prefix = "";
  switch (n) {
    case 0:
      var num = Math.floor(Math.random() * totalrumors);
      var rumor = db.slice("hearsay", "rumors", num, num + 1, 1);
      var output = "console";
      prompt_prefix = " hearsay! ";
      var n = 1;
      break;
    case 1:
      var rumor = db.slice("hearsay", "rumors", last, last + 1, 1);
      var output = "promptframe";
      n = 1;
      break;
    default:
      if (n > last) n = last;
      var rumor = db.slice("hearsay", "rumors", last - n, last, 1);
      //prompt_prefix = "";
      var output = "rumorsframe";
      break;
  }

  for (i = 0; i < n; i++) {
    if (!admin) {
      var padlen = console.screen_columns - prompt_prefix.length - 4;
      var styled = rumor[i].fg + rumor[i].bg + rpad(rumor[i].therumor, padlen);
    } else {
      prompt_prefix = lpad(
        (i + (totalrumors - n) - (totalrumors - last)).toString(),
        2
      );
      var padlen = rumorlength;

      var styled =
        rumor[i].fg +
        rumor[i].bg +
        rpad(rumor[i].therumor, padlen) +
        "\0010\1n\1w|" +
        rumor[i].user;
    }

    switch (output) {
      case "console":
        console.putmsg(leetcolor(prompt_prefix) + bracket(styled) + "\r\n");
        break;
      case "promptframe":
        promptframe.putmsg(prompt_prefix + bracket(styled) + "\r\n");
        break;
      case "rumorsframe":
        rumorsframe.putmsg(prompt_prefix + bracket(styled) + "\r\n");
        break;
    }
  }
}

function bracket(string) {
  bracketed = "\0010\1n\1w[" + string + "\1n\1w]";
  return bracketed;
}

function rpad(str, length, padString) {
  if (!padString) var padString = " ";
  if (str.length > length) str = str.substring(0, length);
  while (str.length < length) str = str + padString;

  return str;
}

function lpad(str, length, padString) {
  if (!padString) var padString = " ";
  if (str.length > length) str = str.substring(0, length);
  while (str.length < length) str = padString + str;
  return str;
}

// Some strings did NOT like using this version of rpad

/*String.prototype.rpad = function(pad, len) {
        while (pad.length < len) {
            pad += pad;
        }
        return this + pad.substr(0, len-this.length);
    }*/

String.prototype.lpad = function (pad, len) {
  while (pad.length < len) {
    pad += pad;
  }
  return pad.substr(0, len - this.length) + this;
};

String.prototype.topromptframe = function (clear, cycle, time) {
  if (clear) promptframe.clear();

  promptframe.putmsg(this);

  if (cycle) promptframe.cycle();

  if (time) sleep(time);

  return;
};

String.prototype.toinputframe = function (clear, cycle, time) {
  if (clear) inputframe.clear();

  inputframe.putmsg(this);

  if (cycle) inputframe.cycle();

  if (time) sleep(time);

  return;
};

function leetcolor(string) {
  return strip_ctrl(string)
    .split(" ")
    .map(function (e) {
      return (
        color_white +
        e.charAt(0) +
        color_bright +
        e.charAt(1) +
        color_normal +
        e.slice(2, e.length - 1) +
        color_white +
        e.slice(e.length - 1)
      );
    })
    .join(" ");
}

function yesno(YN) {
  "Y/N".topromptframe(0, 1, 0);
  if ((YN = "Y")) return "Y";
  else return "N";
}

// If run without argument, display random rumor

switch (argv[0]) {
  case "MENU":
    console.clear();
    main();
    break;
  default:
    showRumor(0);
    exit();
    break;
}
